Imports System.Windows.Forms
Imports System.Collections.Generic
Imports System.Drawing
Imports System.Drawing.Printing
Imports RootPro.RootProCAD


<CLSCompliant(False)> _
Public Class Form1

    Private app As RootProCADApplication = Nothing
    Private selectedPaperRowKind As Integer = -1    ' IĂp
    Private paperRowKinds As New List(Of Integer)   ' pID̔z

    Public Sub New(ByVal app As RootProCADApplication)
        Me.app = app

        InitializeComponent()
    End Sub

    ''' <summary>
    ''' tH[ǂݍ܂ꂽƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load

        ' CXg[Ăv^̈ꗗR{{bNXɒǉ
        Dim printers As PrinterSettings.StringCollection = PrinterSettings.InstalledPrinters
        Dim pd As PrintDocument = New PrintDocument()
        Dim defaultPrinterName As String = pd.PrinterSettings.PrinterName
        For Each printerName As String In printers
            Dim index As Integer = printerComboBox.Items.Add(printerName)

            If printerName = defaultPrinterName Then
                printerComboBox.SelectedIndex = index
            End If
        Next printerName
        If printers.Count = 0 Then
            MessageBox.Show("v^CXg[Ă܂B")
            printButton.Enabled = False
            Return
        End If

    End Sub

    ''' <summary>
    ''' [t@C̒ǉ] {^NbNƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub addFileButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles addFileButton.Click

        ' }ʃt@Cǉ邽߂ɁAt@CI_CAO{bNX\
        Dim openFileDialog As New OpenFileDialog()
        openFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
        openFileDialog.Filter = "RootPro CAD }ʃt@C (*.rpcd;*.rpct;*.djc;*.dj2;*.djt)|*.rpcd;*.rpct;*.djc;*.dj2;*.djt"
        openFileDialog.FilterIndex = 1
        openFileDialog.RestoreDirectory = True
        openFileDialog.Multiselect = True
        openFileDialog.Title = "}ʃt@Cǉ"

        If openFileDialog.ShowDialog() = DialogResult.OK Then
            ' Iꂽt@CXgr[ɒǉ
            Dim fileNames As String() = openFileDialog.FileNames
            For Each fileName As String In fileNames
                Dim listViewItem As ListViewItem = fileListView.Items.Add(System.IO.Path.GetFileName(fileName))
                listViewItem.SubItems.Add(System.IO.Path.GetDirectoryName(fileName))
                listViewItem.Name = fileName
            Next fileName
        End If

    End Sub

    ''' <summary>
    ''' [t@C̍폜] {^NbNƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub removeFileButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles removeFileButton.Click

        If fileListView.SelectedItems.Count = 0 Then
            MessageBox.Show("[t@Cꗗ] ō폜}ʃt@CIĂB")
            Return
        End If

        For Each listViewItem As ListViewItem In fileListView.SelectedItems
            listViewItem.Remove()
        Next listViewItem

    End Sub

    ''' <summary>
    ''' [] {^NbNƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub closeButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles closeButton.Click

        Close()

    End Sub

    ''' <summary>
    ''' [}ʂ̈ݒgp] `FbN{bNX̃`FbNԂύXꂽƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub useDocSettingCheckBox_CheckedChanged(ByVal sender As Object, ByVal e As EventArgs)

        Dim useDocSetting As Boolean = useDocSettingCheckBox.Checked

        monoPrintCheckBox.Enabled = Not useDocSetting
        paperComboBox.Enabled = Not useDocSetting
        portraitRadioButton.Enabled = Not useDocSetting
        landscapeRadioButton.Enabled = Not useDocSetting
        autoScaleRadioButton.Enabled = Not useDocSetting
        manualScaleRadioButton.Enabled = Not useDocSetting
        scaleTextBox.Enabled = Not useDocSetting

    End Sub


    ''' <summary>
    ''' [v^] R{{bNX̑IύXꂽƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub printerComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles printerComboBox.SelectedIndexChanged

        ' pTCYR{{bNXNA
        paperComboBox.Items.Clear()

        ' ۑĂpIDzNA
        paperRowKinds.Clear()

        ' Iꂽv^Ŏgp\ȗpނ擾
        Dim printerName As String = CStr(printerComboBox.SelectedItem)
        Dim pd As New PrintDocument()
        pd.PrinterSettings.PrinterName = printerName
        Dim paperSizes As PrinterSettings.PaperSizeCollection = pd.PrinterSettings.PaperSizes

        ' pTCYR{{bNXɗpނǉ
        For Each paperSize As PaperSize In paperSizes
            Dim index As Integer = paperComboBox.Items.Add(paperSize.PaperName)

            ' pIDۑĂ
            paperRowKinds.Add(paperSize.RawKind)
        Next paperSize

        ' OIĂpꍇ́A̗pI
        Dim paperSelected As Boolean = False
        For i As Integer = 0 To paperRowKinds.Count - 1
            If paperRowKinds(i) = selectedPaperRowKind Then
                paperComboBox.SelectedIndex = i
                paperSelected = True
                Exit For
            End If
        Next

        ' OIĂpȂꍇ́AftHg̗pI
        If Not paperSelected Then
            Dim defaultPaperRowKind As Integer = pd.DefaultPageSettings.PaperSize.RawKind

            For i As Integer = 0 To paperRowKinds.Count - 1
                If paperRowKinds(i) = defaultPaperRowKind Then
                    paperComboBox.SelectedIndex = i
                    Exit For
                End If
            Next
        End If

    End Sub


    ''' <summary>
    ''' pTCYR{{bNX̑IύXꂽƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub paperComboBox_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles paperComboBox.SelectedIndexChanged

        ' Iꂽp̗pIDۑ
        Dim index As Integer = paperComboBox.SelectedIndex
        If index >= 0 Then
            selectedPaperRowKind = paperRowKinds(index)
        Else
            selectedPaperRowKind = -1
        End If

    End Sub


    ''' <summary>
    ''' [s] {^NbNꂽƂ̏
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    Private Sub printButton_Click(ByVal sender As Object, ByVal e As EventArgs) Handles printButton.Click

        If fileListView.Items.Count = 0 Then
            MessageBox.Show("}ʃt@CǉĂB")
            Return
        End If

        ' Xgr[̔wiFNA
        fileListView.Focus()
        For Each listViewItem As ListViewItem In fileListView.Items
            listViewItem.BackColor = fileListView.BackColor
        Next listViewItem
        fileListView.Update()

        ' v^̃`FbN
        If printerComboBox.SelectedIndex < 0 Then
            MessageBox.Show("v^IĂ܂B")
            Return
        End If
        Dim printerName As String = CStr(printerComboBox.SelectedItem)


        ' ݒ擾
        Dim useDocSetting As Boolean = useDocSettingCheckBox.Checked
        Dim monoPrint As Boolean = monoPrintCheckBox.Checked
        Dim landscape As Boolean = landscapeRadioButton.Checked
        Dim autoScale As Boolean = autoScaleRadioButton.Checked
        Dim scale As Double = 100.0
        If Not autoScale Then
            If Not System.Double.TryParse(scaleTextBox.Text, scale) OrElse scale <= 0 Then
                MessageBox.Show("{̎w肪ԈĂ܂B")
                Return
            End If
        End If

        ' p^Cṽ`FbN
        If useDocSetting AndAlso selectedPaperRowKind < 0 Then
            MessageBox.Show("pIĂ܂B")
            Return
        End If


        Cursor.Current = System.Windows.Forms.Cursors.WaitCursor

        For Each listViewItem As ListViewItem In fileListView.Items
            ' ݈̃XgACeIԂɂ
            fileListView.SelectedItems.Clear()
            listViewItem.Selected = True
            listViewItem.Focused = True
            fileListView.Update()

            ' }ʃt@C̃t@CpX擾
            Dim filePath As String = listViewItem.Name

            Dim doc As Document = Nothing
            Dim docOpened As Boolean = False

            ' }ʃt@CłɊJĂ邩ׂ
            Dim docs As DocumentCollection = app.Documents
            Dim docCount As Integer = docs.Count
            For i As Integer = 0 To docCount - 1
                If String.Compare(filePath, docs(i).FullName, True) = 0 Then
                    doc = docs(i)
                    docOpened = True
                    Exit For
                End If
            Next

            ' }ʃt@CJĂȂȂJ
            If Not docOpened Then
                doc = docs.Open(filePath)
            End If
            If doc Is Nothing Then
                Continue For
            End If

            ' Ǝ̐ݒgpȂA}ʂ̈ݒύX
            If Not useDocSetting Then
                doc.PrintSettings.PaperSizeKind = selectedPaperRowKind
                doc.PrintSettings.PrintBlackAndWhite = monoPrint
                doc.PrintSettings.Landscape = landscape
                doc.PrintSettings.ScaleMode = IIf(autoScale, PrintScaleMode.FitToPaper, PrintScaleMode.Scale)
                doc.PrintSettings.Scale = scale * 0.01
            End If


            ' }ʓ̗p
            Dim drawingCount As Integer = doc.Drawings.Count
            For i As Integer = 0 To drawingCount - 1
                Dim drawing As Drawing = doc.Drawings(i)

                ' p݈̂
                If Not TypeOf drawing Is Paper Then
                    Continue For
                End If
                ' ȂݒɂȂĂp͈Ȃ
                If Not drawing.Printable Then
                    Continue For
                End If
                doc.CurrentDrawing = drawing

                ' s
                doc.PrintOut(printerName, 1)
            Next


            ' ̂߂ɐ}ʃt@CJꍇ́AŌɕ
            If Not docOpened Then
                doc.Close()
            End If

            ' ɁAXgACe̔wiFO[ɂ
            listViewItem.BackColor = Color.LightGray
        Next listViewItem

        fileListView.SelectedItems.Clear()
    End Sub

End Class